---
title: Document.registerElement()
slug: Web/API/Document/registerElement
tags:
  - API
  - DOM
  - Deprecated
  - Method
  - Reference
  - Web Components
---
<div>{{APIRef("DOM")}}{{Deprecated_header}}
<div class="warning overheadIndicator">
<p><strong>Warning: </strong><code>document.registerElement()</code> is deprecated in favor of {{DOMxRef("CustomElementRegistry.define()","customElements.define()")}}.</p>
</div>
</div>

<p>{{draft}}</p>

<p>The <code><strong>document.registerElement()</strong></code> method registers a new <a href="/en-US/docs/Web/Web_Components/Custom_Elements">custom element</a> in the browser and returns a constructor for the new element.</p>

<div class="note">
<p><strong>Note:</strong> This is an experimental technology. The browser you use it in must support Web Components. See <a href="/en-US/docs/Web/Web_Components#Enabling_Web_Components_in_Firefox">Enabling Web Components in Firefox</a>.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>constructor</em> = document.registerElement(<em>tag-name</em>, <em>options</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><em>tag-name</em></dt>
 <dd>The name of the custom element. The name must contain a dash (-), for example <code>my-tag</code>.</dd>
 <dt><em>options{{optional_inline}}</em></dt>
 <dd>
 <p>An object with properties <strong>prototype</strong> to base the custom element on, and <strong>extends</strong>, an existing tag to extend. Both of these are optional.</p>
 </dd>
</dl>

<h2 id="Example">Example</h2>

<p>Here is a very simple example:</p>

<pre class="brush: js">var Mytag = document.registerElement('my-tag');
</pre>

<p>Now the new tag is registered in the browser. The <code>Mytag</code> variable holds a constructor that you can use to create a <code>my-tag</code> element in the document as follows:</p>

<pre class="brush: js">document.body.appendChild(new Mytag());</pre>

<p>This inserts an empty <code>my-tag</code> element that will be visible if you use the browser's developer tools. It will not be visible if you use the browser's view source capability. And it won't be visible in the browser unless you add some content to the tag. Here is one way to add content to the new tag:</p>

<pre class="brush: js">var mytag = document.getElementsByTagName("my-tag")[0];
mytag.textContent = "I am a my-tag element.";
</pre>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Document.registerElement")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/Web_Components/Custom_Elements">Custom Elements</a></li>
</ul>
